#### Install library
```
sudo apt-get update

sudo apt install openssl python3-dev libffi-dev pkg-config libjpeg-dev \
    libopenexr-dev libssl-dev autoconf libgmp-dev \
    libfreeimage-dev libtool python3-netifaces python3-psutil build-essential \
    python3-pip rustc cargo
```

#### Install Docker
```
sudo apt-get update

sudo apt-get install \
    apt-transport-https \
    ca-certificates \
    curl \
    gnupg-agent \
    software-properties-common

curl -fsSL https://download.docker.com/linux/ubuntu/gpg | sudo apt-key add -


sudo apt-key fingerprint 0EBFCD88

sudo add-apt-repository \
   "deb [arch=amd64] https://download.docker.com/linux/ubuntu \
   $(lsb_release -cs) \
   stable"

sudo apt-get update

sudo apt-get install docker-ce docker-ce-cli containerd.io

sudo apt-get install docker-ce=18.06.3~ce~3-0~ubuntu containerd.io

sudo usermod -a -G docker $USER
```

#### Install HyperG
```
wget https://github.com/golemfactory/simple-transfer/releases/download/0.3.7/hyperg_0.3.7_linux-x64.tar.gz

## have error
tar xzf hyperg_0.3.7_linux-x64.tar.gz $HOME/.local/bin/

export PATH="$PATH:/home/ubuntu/.local/bin/"

git clone https://github.com/golemfactory/golem.git
```

#### Install python
```
sudo pip3 install virtualenv virtualenvwrapper

export VIRTUALENVWRAPPER_PYTHON=/usr/bin/python3

source /usr/local/bin/virtualenvwrapper.sh

mkvirtualenv --python=$(which python3) golem-env

workon golem-env

pip3 install -r requirements.txt

python3 setup.py develop --prefix=$HOME/.local
```


```
set -e
  URL=https://storage.googleapis.com/gvisor/releases/nightly/latest
  wget ${URL}/runsc
  wget ${URL}/runsc.sha512
  sha512sum -c runsc.sha512
  rm -f runsc.sha512
  sudo mv runsc /usr/local/bin
  sudo chown root:root /usr/local/bin/runsc
  sudo chmod 0755 /usr/local/bin/runsc

runsc install
```