<p align=center>
<img src="./assets/title.png">
</p>

<p align=center>
<h1 align=center>KAIZEN CLI</h1>
</p>

<a target="_blank" href="https://travis-ci.org/PortalNetwork/kaizen-cli" title="CircleCI"><img src="https://travis-ci.org/PortalNetwork/kaizen-cli.svg?branch=master"></a>
<a target="_blank" href="https://github.com/PortalNetwork/kaizen-cli/pulls" title="PRs Welcome"><img src="https://img.shields.io/badge/PRs-welcome-blue.svg"></a>
<a href="#"><img src="https://img.shields.io/hackage-deps/v/lens.svg"/></a>
[![Join the chat at https://gitter.im/PortalNetwork/kaizen-cli](https://badges.gitter.im/PortalNetwork/kaizen-cli.svg)](https://gitter.im/PortalNetwork/kaizen-cli?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge)
<a target="_blank" href="#"><img src="https://img.shields.io/github/license/mashape/apistatus.svg"/></a>

> KAIZEN 是為 DApp 和 DWeb 開發人員所設計的一站式解決方案

| [English](./README.md) | [한국어](./README_KR.md) | [中文](./README_ZH.md) |

## 🚀 概要
KAIZEN 是為 DApp 和 DWeb 開發人員所設計的一站式解決方案。 
KAIZEN 包括:
- 輕鬆開發和管理多個區塊鏈技術
- 在流行的雲提供商上輕鬆構建區塊鏈節點與服務
- 自定義現有區塊鏈技術以滿足您的開發要求

## 📚 目錄

<img align="right" width="250" src="https://kaizen.portal.network/images/demo.png"/>

- [快速開始](#quick-start)
- [專案範例](https://github.com/PortalNetwork/kaizen-examples)
- [指令集](#command-topics)
- [Dapp模板](#dapp-templates)
- [Subgraph模板](#subgraph-templates)
- [插件](#plugins)
- [智能合約](#smart-contracts)
- [實例](#instances)
- [範例](#demo)
- [社群連結](#community)
- [參與貢獻](#contributing)
- [許可證](#licence)

## <a name="quick-start"></a>🚀 快速開始
STEP 1. 透過 npm 安裝 KAIZEN:
```
npm install -g kaizen-cli 
```

STEP 2. 創建專案:
```
kaizen create --template react --name myproject
```

STEP 3. 部署智能合約:
```
kaizen contracts deploy --url https://github.com/PortalNetwork/kaizen-contracts/tree/master/ERC20
```

STEP 4. 上傳專案到 [IPFS](https://ipfs.io), [BTFS](https://www.bittorrent.com/btfs/) 或者 [Swarm](https://ethersphere.github.io/swarm-home/):
```
# Upload to IPFS
kaizen upload ipfs ./build
# or upload to BTFS
kaizen upload btfs ./build
# or upload to Swarm
kaizen upload swarm [file]
```

STEP 5. 部署實例於 AWS 上
```
kaizen instances run nym-loopix-mixnode
```

## <a name="command-topics"></a>🔨 指令集

- [`kaizen config`](commands/config.md) - 設定 KAIZEN
- [`kaizen create`](commands/create.md) - 創建 KAIZEN 專案
- [`kaizen install`](commands/install.md) - 從 GitHub 安裝已經存在的 KAIZEN 
- [`kaizen upload`](commands/upload.md) - 上傳 KAIZEN 專案
- [`kaizen plugins`](commands/plugins.md) - KAIZEN 插件管理功能
- [`kaizen instances`](commands/instances.md) - KAIZEN 運行實例管理功能
- [`kaizen contracts`](commands/contracts.md) - KAIZEN 智能合約管理功能
- [`kaizen blockchains`](commands/blockchains.md) - KAIZEN 區塊鏈管理功能

#### KAIZEN Platform (Alpha)
KAIZEN Platform 目前正在 Alpha 階段
- [`kaizen login`](commands/login.md) - 登入或註冊 KAIZEN Platform
- [`kaizen logout`](commands/logout.md) - 登出 KAIZEN Platform
- [`kaizen nodes`](commands/nodes.md) - KAIZEN Platform 節點管理

## <a name="dapp-templates"></a>📦 Dapp模板
- [React] - Dapp template make by react framework
- [Vue] - Dapp template make by vue framework
- [Plain-near] - Near protocol dapp template simple version
- [React-near] - Near protocol dapp template make by react

## <a name="subgraph-templates"></a>📦 Subgraph模板
- [Subgraph] - Subgraph template, more information please visit [here](https://thegraph.com/docs/)

## <a name="plugins"></a>🏗 插件
- [Bluzelle](https://www.npmjs.com/package/bluzelle) - Decentralized database
- [NKN](https://www.npmjs.com/package/nkn-client) - Data transmisstion
- [ICON](https://www.npmjs.com/package/icon-sdk-js) - Blockchain
- [Orbit](https://www.npmjs.com/package/orbit-db) - Decentralized database
- [Arweave](https://www.npmjs.com/package/arweave) - Decentralized file storage
- [Fluence](https://www.npmjs.com/package/fluence) - Decentralized database
- [Sia](https://sia.tech/) - Decentralized file storage
- [NOIA](http://noia.network/) - Decentralized CDN
- [Near](https://nearprotocol.com/) - Scalable decentralized application
- [Tellor](https://tellor.io/) - Decentralized oracle service
- [Skale](https://skale.network/) - Elastic blockchain network
- [Ren](https://renproject.io/) - Inter-blockchain liquidity for all decentralized applications
- [Nervos](https://www.nervos.org/) - Multi-asset, store of value blockchain
- [Kava](https://www.kava.io/) - Cross-chain CDP platform for leverage assets
- [Zabo](https://zabo.com/) - Multiple crypto wallet provider
- [Loom](https://loomx.io/) - The Production-ready, Multichain Interop Platform for Serious Dapp Developers
- [Ramp](https://instant.ramp.network/) - Ramp Network offer fiat to crypto currency exchange
- [Witnet](https://witnet.io/) - Witnet provides decentralized oracle network
- [0xcert](https://0xcert.org/) - Build decentralized apps using fungible and non-fungible tokens quickly, cost efficiently and securely.

## <a name="smart-contracts"></a>📑 智能合約
- [ERC20](https://github.com/PortalNetwork/kaizen-contracts/tree/master/ERC20) 
- [ERC721](https://github.com/PortalNetwork/kaizen-contracts/tree/master/ERC721)
- [Chainlink](https://github.com/PortalNetwork/kaizen-contracts/tree/master/Chainlink)
- [Hopr](https://github.com/PortalNetwork/kaizen-contracts/tree/master/Hopr)
- [Nucypher](https://github.com/PortalNetwork/kaizen-contracts/tree/master/Nucypher)

## <a name="instances"></a>⚙️ 實例
- [NYM](http://nymtech.net/) - Decentralized privacy
- [Golem](https://golem.network/) - Decentralized cloud computing

## <a name="faucet"></a>🚰 水龍頭
[Join Faucet](https://forms.gle/SSHBeAMBweSWVN5Q7?fbclid=IwAR3k5NWNo8cIavD7t33w4yk0OVSL6iqg18_DVLxbwR_xu4_ZyDARF6ZFK0Q)  
獲取測試網路代幣, [https://faucet.portal.network/](https://faucet.portal.network/):
- [ETH](https://faucet.metamask.io/)
- [ETC](http://kottifaucet.me/)
- [WAN](https://faucet1.wanchain.org/)
- [ICON](https://icon-faucet.ibriz.ai/)
- [TRON](https://www.trongrid.io/faucet)
- [TOMO](https://faucet.testnet.tomochain.com/)
- [QTUM](http://testnet-faucet.qtum.info/#!/)

## <a name="demo"></a>🔌 範例
#### Nifty Game
- [Nifty Game](https://github.com/PortalNetwork/nifty-game/) - Nifty is a non-fungible token game build by KAIZEN.
![Nifty Game](https://github.com/PortalNetwork/nifty-game/blob/develop/cardbattle.gif?raw=true)

#### Dchat
- [Dchat](http://dchat.web3infra.io/)

## <a name="community"></a>💡 社群連結
- [Gitter](https://gitter.im/PortalNetwork/kaizen-cli)
- [Twitter](https://twitter.com/itisportal)
- [Facebook](https://www.facebook.com/portalnetworkofficial)
- [Reddit](https://www.reddit.com/r/portalnetwork)
- [Telegram](https://t.me/portalnetworkofficial)
- [Medium](https://medium.com/portalnetworkofficial)

## <a name="contributing"></a>📣 參與貢獻
我們非常歡迎社群的貢獻。

若您想參與一起讓 KAIZEN 更好使用，請參考 [CONTRIBUTING.md](./CONTRIBUTING.md) 來看看如何貢獻。

*快速開始：您可以透過 [help wanted](https://github.com/PortalNetwork/kaizen-cli/labels/help%20wanted) 或者 [good first issue](https://github.com/PortalNetwork/kaizen-cli/labels/good%20first%20issue) 標籤找到可以參與貢獻的任務。

## <a name="contact"></a>📧 聯絡
如果您有任何問題請聯繫 **chris@portal.network** 或者加入我們的 Telegram: [http://bit.ly/2XjhQV2](http://bit.ly/2XjhQV2)

## <a name="licence"></a>🗒 許可證
詳細內容請參考 [LICENSE](./LICENSE)
